import utilities

#
#
#
class HiscoreManager:
	def __init__(self):

		self.hiscore_holders = ["---", "---", "---", "---", "---", "---", "---", "---", "---", "---"]
		self.hiscore_values = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		self.loadHiscores()

	def render(self):
		for lineIndex in range(0, 10):
			line = self.hiscore_holders[lineIndex] + " - " + str(self.hiscore_values[lineIndex])
			
			utilities.drawTextToDisplay(line, (120, 48 + (lineIndex * 16)), utilities.TEXT_COLOR_BLUE)
	#
	#
	#
	def loadHiscores(self):
		f = file("VanSangsPain/hiscores.txt", 'r')		
		lines = f.read().splitlines()
		
		for lineIndex in range(0, 10):
			lineCut = lines[lineIndex].split(',')
			initials = lineCut[0]
			value = int(lineCut[1])
			
			self.hiscore_holders[lineIndex] = initials
			self.hiscore_values[lineIndex] = value				
		
	#
	#
	#
	def saveHiscores(self):
		f = open("VanSangsPain/hiscores.txt", 'w')		

		for lineIndex in range(0, 10):
			line = self.hiscore_holders[lineIndex] + ',' + str(self.hiscore_values[lineIndex]) + '\n'				
			f.write(line)
			
		f.close()	

	# 
	#
	#
	def addHiscore(self, initials, value):
		for lineIndex in range(0, 10):
			if value > self.hiscore_values[lineIndex]:
				self.hiscore_holders.insert(lineIndex, initials)					
				self.hiscore_values.insert(lineIndex, value)
				break
				
		while len(self.hiscore_holders) > 10:
			del self.hiscore_holders[-1]		
			del self.hiscore_values[-1]	

	# 
	#
	#
	def resetHiscores(self):
			self.inputHiscoreInitials = ['A', '.', '.']
			self.inputHiscoreCursorIndex = 0
			self.inputHiscoreTextIndex = 0

	# 
	#
	#
	def setInitialAndMoveToPrev(self):
		self.inputHiscoreTextIndex -= 1
		if self.inputHiscoreTextIndex < 0:
			self.inputHiscoreTextIndex = len(utilities.getTextString()) - 1
			
		self.inputHiscoreInitials[self.inputHiscoreCursorIndex] = utilities.getTextString()[self.inputHiscoreTextIndex]
		
	# 
	#
	#
	def setInitialAndMoveToNext(self):
		self.inputHiscoreTextIndex += 1
		if self.inputHiscoreTextIndex >= len(utilities.getTextString()):
			self.inputHiscoreTextIndex = 0

		self.inputHiscoreInitials[self.inputHiscoreCursorIndex] = utilities.getTextString()[self.inputHiscoreTextIndex]
		
	# 
	#
	#
	def confirmInitialsOrMoveToNext(self, score):
		self.inputHiscoreCursorIndex += 1
		if self.inputHiscoreCursorIndex > 2:						
			initials = self.inputHiscoreInitials[0] + self.inputHiscoreInitials[1] + self.inputHiscoreInitials[2]  
			self.addHiscore(initials, score)
			self.saveHiscores()
			return True
		else:						
			self.inputHiscoreInitials[self.inputHiscoreCursorIndex] = utilities.getTextString()[self.inputHiscoreTextIndex]			
		
		return False
	
	#
	#
	#
	def renderHiscoreEntryPanel(self, offset, score):
		utilities.blitSignsToDisplaySurface((104, 120), (96, 64, 112, 16))
		utilities.drawTextToDisplay(self.inputHiscoreInitials[0] + self.inputHiscoreInitials[1] + self.inputHiscoreInitials[2] + ' - ' + str(score), (104 + 5, 119), utilities.TEXT_COLOR_GREEN)
		utilities.blitSignsToDisplaySurface((104 + 5 + (self.inputHiscoreCursorIndex * utilities.CHAR_WIDTH), 120), (208 + (offset * utilities.CHAR_WIDTH), 64, utilities.CHAR_WIDTH, utilities.CHAR_HEIGHT))
		
	#
	#
	#
	def getLowestHiscoreValue(self):
		return self.hiscore_values[9]