import utilities
import tileLayer

#
#
#
class Level:	
	#
	#
	#
	def __init__(self):
		self.backgroundTileLayer = tileLayer.TileLayer()
		self.midgroundTileLayer = tileLayer.TileLayer()
		self.foregroundTileLayer = tileLayer.TileLayer()
		
	#
	#
	#
	def load(self, levelPrefix):
		bgFilename = levelPrefix + '_BG.csv'
		self.backgroundTileLayer.loadCSV(bgFilename)
		
		mgFilename = levelPrefix + '_MG.csv'
		self.midgroundTileLayer.loadCSV(mgFilename)
		
		fgFilename = levelPrefix + '_FG.csv'
		self.foregroundTileLayer.loadCSV(fgFilename)
	
	#
	#
	#
	def getBackgroundTileNr(self, x, y):
		return self.backgroundTileLayer.getTileNrAtCoordinate(x, y)
	
	#
	#
	#
	def getMidgroundTileNr(self, x, y):
		return self.midgroundTileLayer.getTileNrAtCoordinate(x, y)
	
	#
	#
	#
	def setMidgroundTileNr(self, x, y, newTileNr):
		self.midgroundTileLayer.setTileNrAtCoordinate(x, y, newTileNr)
		
	#
	#
	#
	def getForegroundTileNr(self, x, y):
		return self.foregroundTileLayer.getTileNrAtCoordinate(x, y)
		
	#
	#
	#
	def findFirstTileNrInMidground(self, searchTileNr):	
		for row in range(0, utilities.TILE_ROWS):
			for col in range(0, utilities.TILE_COLS):
				checkTileNr = self.midgroundTileLayer.getTileNrAtCoordinate(col, row)				
				if searchTileNr == checkTileNr:
					return (col, row)

		return None
		
	#
	#
	#
	def replaceAllTileNrOccurrencesInMidground(self, sourceTileNr, targetTileNr):
		for row in range(0, utilities.TILE_ROWS):
			for col in range(0, utilities.TILE_COLS):
				checkTileNr = self.midgroundTileLayer.getTileNrAtCoordinate(col, row)				
				if sourceTileNr == checkTileNr:
					self.midgroundTileLayer.setTileNrAtCoordinate(col, row, targetTileNr)				
		
	#
	#
	#
	def isMidgroundBlockedAtPixelPosition(self, pixelX, pixelY):
		x = int(pixelX / utilities.TILE_WIDTH)
		y = int(pixelY / utilities.TILE_HEIGHT)
		tileNr = self.midgroundTileLayer.getTileNrAtCoordinate(x, y)
		
		if tileNr != -1:
			return True
			
		return False
		 