import pygame
import sys
import random
import math

import app
import utilities

FPS = 60

#
#
#
def main():
	pygame.mixer.pre_init(frequency=22050, size=-16, channels=2, buffer=512)
	pygame.init()

	#print("Init Joystick start")
	pygame.joystick.init()
	joysticks = [pygame.joystick.Joystick(x) for x in range(pygame.joystick.get_count())]
	for joystick in joysticks:
		joystick.init()
		#print(joystick.get_name())
	#print("Init Joystick end")

	utilities.prepareGraphicsSystem()

	fpsClock = pygame.time.Clock()

	currentScore = 0 #127
	currentLives = 3 #1
	currentLevel = 1 #23
	myGame = app.App(currentScore, currentLives, currentLevel)

	while True:
		for event in pygame.event.get():
			if event.type == pygame.QUIT:
				terminate()

			if myGame.handleEvent(event) == True:
				terminate()

		myGame.update()
		myGame.render()

		utilities.scaleDisplaySurface()

		pygame.display.update()
		fpsClock.tick(FPS)

#
#
#
def terminate():
	pygame.quit()
	sys.exit()


#
#
#
if __name__ == '__main__':
	main()