import pygame

class MusicManager:
	def __init__(self):
		self.doPlay = False
		
		self.musicList = [
			'VanSangsPain/music/Leveler4.mp3',	
			'VanSangsPain/music/Leveler3.mp3',	
			'VanSangsPain/music/Leveler_A.mp3',	
			'VanSangsPain/music/Leveler_B.mp3',	
			'VanSangsPain/music/Level_Vers_3.mp3',		
			'VanSangsPain/music/LoopMic2.mp3',	
			'VanSangsPain/music/Soon.mp3'	
		] 
				
		self.playIndex = -1	
		self.loadSettings()

		self.playMusic(self.doPlay)

	def update(self):		
		isBusy = pygame.mixer.music.get_busy()
		if isBusy == False:
			self.playIndex += 1
			if self.playIndex == len(self.musicList):
				self.playIndex = 0
			
			pygame.mixer.music.load(self.musicList[self.playIndex])
			pygame.mixer.music.set_volume(0.5)
			pygame.mixer.music.play(0, 0.0)
			pygame.mixer.music.rewind()
		
			self.playMusic(self.doPlay)
				
	def getPlayMusic(self):
		return self.doPlay
			
	def playMusic(self, flag):
		#print("MusicManager.playMusic: " + str(flag))
		
		if flag == True:
			pygame.mixer.music.set_volume(0.5)
			self.doPlay = True
		else:
			pygame.mixer.music.set_volume(0.0)
			self.doPlay = False

	def loadSettings(self):
		f = file('VanSangsPain/music_setting.txt', 'r')		
		lines = f.read().splitlines()
		
		if (lines[0] == '1'):
			self.doPlay = True
		else:
			self.doPlay = False	
			
		#print("Load music setting: " + lines[0])
		
	def saveSettings(self):
		f = open("VanSangsPain/music_setting.txt", 'w')		

		if self.doPlay == True:
			f.write('1')
			#print("Save music setting: 1")
		else:
			f.write('0')
			#print("Save music setting: 0")
						
		f.close()	
